/*
 * SBH.H
 *
 * header file for SBH.C
 *
 */
#include "ip.h"
#include "hist.h"

struct bubble {
  Sp ctr;                       /* center position */
  unsigned int area;            /* area (no pixels) */
};



/* function prototypes */
/* xah.c */
extern void main (int argc, char **argv);
extern void fail_alloc (char *prompt, int status);
extern void exitmess (char *prompt, int status);
extern void prompt_file_name (char *buf);
extern void extract_area (int nd, unsigned int *area, struct bubble *cbub);
#if defined(LINUX)
extern int compare (int *a1, int *a2);
extern int bcomp (struct bubble *b1, struct bubble *b2);
#else
extern int compare (const void *a1, const void *a2);
extern int bcomp (const void *b1, const void *b2);
#endif
/* rfill.c */
extern unsigned int proc_img (int x, int y);
extern void erase_region (int x, int y, int index);
extern void mark_centroid (double x, double y, int index, int flood_reg_index, Image * aoi);
extern int find_left_x (int x, int y, int stop_index, Image * aoi);
extern int ln_fill (int x, int y, int index, double *xc, double *yc, int stop_index, Image * aoi);
extern unsigned int rfill (int x, int y, int index, double *xc, double *yc, int img_type, Image * aoi);
/* ah_AOI.c */
extern int ah_AOI (int x1, int y1, int x2, int y2, Image * aoi, Image * imgOut, struct bubble *cbub, int nmax);
extern void encode_ba (double mean_a, double rmsq_a, struct bubble *b, int nd, Image * ip, int value);
/* aoi_io.c */
extern void write_bub_data (FILE * file,
                            float foo, int np, struct bubble *cbub, int nd);
extern void write_aoi_data (FILE * file,
                            float foo, int np, struct Histo *h, int X_SQ);
/* aoi_hist.c */
extern double eval_mean (int nd, unsigned int *oarea);
extern double eval_sdev (double mean_a, int nd, unsigned int *oarea);
extern double eval_skew (double mean_a, double sdev_a, int nd,
                         unsigned int *oarea);
extern double find_hist_mean (int nb, float *hist, double bw);
extern struct Histo *eval_hist (int BIN_METHOD, float *data, int nd, int SRT);
extern void construct_hist (int n, float *data,
                            float *hist, double bw, double base);
extern void construct_shist (int n, float *data,
                             float *hist, double bw, double base);
extern void area_hist (int n, unsigned int *a, unsigned int a_base,
                       unsigned int *ah, int bw);
/* vor_io.c */
extern void write_vin_file (FILE * file, int n, int xmin, int ymin, int xmax, int ymax, struct bubble *C);
